"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveSplitChunksOptions = void 0;
// | {
//     /**
//      * Size of the part of the chunk with the type of the key.
//      */
//     [k: string]: number;
// };
function resolveSplitChunksOptions(op) {
    var _a;
    if (!op || op == null) {
        return undefined;
    }
    else {
        (_a = op.cacheGroups) !== null && _a !== void 0 ? _a : (op.cacheGroups = {});
        return {
            chunks: op.chunks,
            maxAsyncRequests: op.maxAsyncRequests,
            maxInitialRequests: op.maxInitialRequests,
            minChunks: op.minChunks,
            minSize: op.minSize,
            enforceSizeThreshold: op.enforceSizeThreshold,
            minRemainingSize: op.minRemainingSize,
            cacheGroups: op.cacheGroups
                ? Object.fromEntries(Object.entries(op.cacheGroups).map(([key, group]) => {
                    let normalizedGroup = {
                        test: group.test ? group.test.source : undefined,
                        name: group.name,
                        priority: group.priority,
                        minChunks: group.minChunks,
                        chunks: group.chunks
                    };
                    return [key, normalizedGroup];
                }))
                : undefined
        };
    }
}
exports.resolveSplitChunksOptions = resolveSplitChunksOptions;
//# sourceMappingURL=splitChunks.js.map