"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Watching_instances, _Watching_initial, _Watching_closed, _Watching_collectedChangedFiles, _Watching_collectedRemovedFiles, _Watching_invalidate, _Watching_go, _Watching_done, _Watching_mergeWithCollected;
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
class Watching {
    constructor(compiler, watchOptions, handler) {
        _Watching_instances.add(this);
        _Watching_initial.set(this, void 0);
        _Watching_closed.set(this, void 0);
        _Watching_collectedChangedFiles.set(this, void 0);
        _Watching_collectedRemovedFiles.set(this, void 0);
        this.compiler = compiler;
        this.running = false;
        __classPrivateFieldSet(this, _Watching_initial, true, "f");
        __classPrivateFieldSet(this, _Watching_closed, false, "f");
        this.watchOptions = watchOptions;
        this.handler = handler;
        process.nextTick(() => {
            if (__classPrivateFieldGet(this, _Watching_initial, "f"))
                __classPrivateFieldGet(this, _Watching_instances, "m", _Watching_invalidate).call(this);
            __classPrivateFieldSet(this, _Watching_initial, false, "f");
        });
    }
    watch(files, dirs, missing) {
        this.pausedWatcher = null;
        this.watcher = this.compiler.watchFileSystem.watch(files, dirs, missing, this.lastWatcherStartTime, this.watchOptions, (err, fileTimeInfoEntries, contextTimeInfoEntries, changedFiles, removedFiles) => {
            if (err) {
                return this.handler(err);
            }
            __classPrivateFieldGet(this, _Watching_instances, "m", _Watching_invalidate).call(this, fileTimeInfoEntries, contextTimeInfoEntries, changedFiles, removedFiles);
        }, () => { });
    }
    close(callback) {
        __classPrivateFieldSet(this, _Watching_closed, true, "f");
        if (this.watcher) {
            this.watcher.close();
            this.watcher = null;
        }
        if (this.pausedWatcher) {
            this.pausedWatcher.close();
            this.pausedWatcher = null;
        }
        this.compiler.watching = undefined;
        this.compiler.watchMode = false;
        callback();
    }
    invalidate() {
        __classPrivateFieldGet(this, _Watching_instances, "m", _Watching_invalidate).call(this);
    }
}
_Watching_initial = new WeakMap(), _Watching_closed = new WeakMap(), _Watching_collectedChangedFiles = new WeakMap(), _Watching_collectedRemovedFiles = new WeakMap(), _Watching_instances = new WeakSet(), _Watching_invalidate = function _Watching_invalidate(fileTimeInfoEntries, contextTimeInfoEntries, changedFiles, removedFiles) {
    if (this.running) {
        __classPrivateFieldGet(this, _Watching_instances, "m", _Watching_mergeWithCollected).call(this, changedFiles, removedFiles);
        console.log("hit change but rebuild is not finished, pending files: ", [
            ...__classPrivateFieldGet(this, _Watching_collectedChangedFiles, "f"),
            ...__classPrivateFieldGet(this, _Watching_collectedRemovedFiles, "f")
        ]);
        return;
    }
    __classPrivateFieldGet(this, _Watching_instances, "m", _Watching_go).call(this, changedFiles, removedFiles);
}, _Watching_go = function _Watching_go(changedFiles, removedFiles) {
    this.running = true;
    if (this.watcher) {
        this.pausedWatcher = this.watcher;
        this.lastWatcherStartTime = Date.now();
        this.watcher.pause();
        this.watcher = null;
    }
    else if (!this.lastWatcherStartTime) {
        this.lastWatcherStartTime = Date.now();
    }
    const compile = this.compiler.options.devServer && !__classPrivateFieldGet(this, _Watching_initial, "f")
        ? (changes, removals, cb) => this.compiler.rebuild(changes, removals, cb)
        : (_a, _b, cb) => this.compiler.build(cb);
    const begin = Date.now();
    this.compiler.hooks.watchRun.callAsync(this.compiler, err => {
        if (err)
            __classPrivateFieldGet(this, _Watching_instances, "m", _Watching_done).call(this, err);
        compile(changedFiles, removedFiles, err => {
            __classPrivateFieldGet(this, _Watching_instances, "m", _Watching_done).call(this, err);
            console.log("rebuild success, time cost", Date.now() - begin, "ms");
        });
    });
}, _Watching_done = function _Watching_done(error) {
    this.running = false;
    if (error) {
        return this.handler(error);
    }
    const stats = new _1.Stats(this.compiler.compilation);
    this.handler(undefined, stats);
    this.compiler.hooks.done.callAsync(stats, () => {
        const hasPending = __classPrivateFieldGet(this, _Watching_collectedChangedFiles, "f") || __classPrivateFieldGet(this, _Watching_collectedRemovedFiles, "f");
        // If we have any pending task left, we should rebuild again with the pending files
        if (hasPending) {
            const pendingChengedFiles = __classPrivateFieldGet(this, _Watching_collectedChangedFiles, "f");
            const pendingRemovedFiles = __classPrivateFieldGet(this, _Watching_collectedRemovedFiles, "f");
            __classPrivateFieldSet(this, _Watching_collectedChangedFiles, undefined, "f");
            __classPrivateFieldSet(this, _Watching_collectedRemovedFiles, undefined, "f");
            __classPrivateFieldGet(this, _Watching_instances, "m", _Watching_go).call(this, pendingChengedFiles, pendingRemovedFiles);
        }
        process.nextTick(() => {
            if (!__classPrivateFieldGet(this, _Watching_closed, "f")) {
                this.watch(this.compiler.compilation.fileDependencies, this.compiler.compilation.contextDependencies, this.compiler.compilation.missingDependencies);
            }
        });
    });
}, _Watching_mergeWithCollected = function _Watching_mergeWithCollected(changedFiles, removedFiles) {
    if (!changedFiles)
        return;
    if (!__classPrivateFieldGet(this, _Watching_collectedChangedFiles, "f")) {
        __classPrivateFieldSet(this, _Watching_collectedChangedFiles, new Set(changedFiles), "f");
        __classPrivateFieldSet(this, _Watching_collectedRemovedFiles, new Set(removedFiles), "f");
    }
    else {
        for (const file of changedFiles) {
            __classPrivateFieldGet(this, _Watching_collectedChangedFiles, "f").add(file);
            __classPrivateFieldGet(this, _Watching_collectedRemovedFiles, "f").delete(file);
        }
        for (const file of removedFiles) {
            __classPrivateFieldGet(this, _Watching_collectedChangedFiles, "f").delete(file);
            __classPrivateFieldGet(this, _Watching_collectedRemovedFiles, "f").add(file);
        }
    }
};
exports.default = Watching;
//# sourceMappingURL=watching.js.map